<?php

// Current datafeed script version
$script_version = "1.17";

// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed VirtueMart</b><br />";
	echo "script version <b>" . $script_version . "</b><br />";
	exit;
}

if (!ini_get("safe_mode")) {
    set_time_limit(0);
}
ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);

$_SVR = array();

##### Include configuration files ################################################

# You need to do place this file in your root directory, where the configuration file is located.
# Otherwise, if you place this file in another directory please modify the line below with the path to the directory where the configuration file is located.
# In this case, $site_base_path should contain the path that is found in $mosConfig_absolute_path variable from the configuration.php file, followed by / 
$site_base_path = "./";

# Once all is set up you need to check the result and make sure the output is correct
# Point the browser to http://www.example.com/path_to_datafeed/cliccaprezzi_datafeed.php and look into the source code of the out put
# What you need to see is something like this
# Category|Manufacturer|Part Number|Merchant Code|Product Name|Product Description|Product URL|Product Image URL|Product Price|Currency|Shipping value|Availability|GTIN (UPC/EAN/ISBN) 

##### Avoid any modifications below this line #####

// Include configuration file
if(!file_exists($site_base_path . "configuration.php")) {
	exit('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Please ensure that datafeed_cliccaprezzi.php is in the root directory, or make sure the path to the directory where the configuration file is located is defined corectly above in $site_base_path variable</BODY></HTML>');
}
else {
	require_once($site_base_path . "configuration.php");
}

// Used for compatibility with Joomla 1.5
if (file_exists($site_base_path . 'administrator/components/com_virtuemart/compat.joomla1.5.php')) {
	define( '_VALID_MOS', 1 );
	define( '_JEXEC', 1 );
	include_once($site_base_path . 'administrator/components/com_virtuemart/compat.joomla1.5.php' );	
}

// Include configuration 
include_once($site_base_path . 'administrator/components/com_virtuemart/virtuemart.cfg.php' );

####################################################################

// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |

##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_availability = (@$_GET['availability'] == "off") ? "off" : "on";
$add_gtin = (@$_GET['gtin'] == "off") ? "off" : "on";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$tagging_params = (@$_GET['tagging_params'] != "") ? urldecode($_GET['tagging_params']) : "utm_source=cliccaprezzi&utm_medium=cpc&utm_campaign=direct_link";
$show_description = (@$_GET['description'] == "off") ? "off" : ((@$_GET['description'] == "limited") ? "limited" : "on");
$show_image = (@$_GET['image'] == "off") ? "off" : "on";
$show_manufacturer = (@$_GET['manufacturer'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock'] == "on") ? "on" : "off";
$currency = (@$_GET['currency'] != "") ? strtoupper($_GET['currency']) : "";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$use_path = (@$_GET['usepath'] != "") ? $_GET['usepath'] : "";
$force_folder = (@$_GET['forcefolder'] != "") ? $_GET['forcefolder'] : "";
$limit = (@$_GET['limit'] != "") ? $_GET['limit'] : "";

####################################################################

// Force base path
if ($force_path == "on") {
	$mosConfig_live_site = ($use_path != "") ? $use_path : $_SERVER['HTTP_HOST'];
}

// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	
	echo "<b>Datafeed VirtueMart</b><br />";
	echo "script version <b>" . $script_version . "</b><br /><br /><br />";
		
	echo "<b>Taxes options</b> - possible values on, off default value on<br />";
	echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	echo "<b>Store taxes options</b> - possible values on, off default value on<br />";
	echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	echo "<b>Discount options</b> - possible values on, off default value on<br />";
	echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	
	echo "<b>Add VAT to prices</b> - possible values on, off default value off<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
	
	echo "<b>VAT value</b> - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";

	echo "<b>Add shipping to datafeed</b> - possible values on, off default value off<br />";
	echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=on" . "\" >" . $script_basepath . "?shipping=on" . "</a><br /><br />";
	
	echo "<b>Add availability to datafeed</b> - possible values on, off default value on<br />";
	echo "availability=on (on,off) <a href=\"" . $script_basepath . "?availability=off" . "\" >" . $script_basepath . "?availability=off" . "</a><br /><br />";
	
	//echo "<b>Add GTIN to datafeed</b> - possible values on, off default value on<br />";
	//echo "gtin=on (on,off) <a href=\"" . $script_basepath . "?gtin=off" . "\" >" . $script_basepath . "?gtin=off" . "</a><br /><br />";
		
	echo "<b>Add GA Tagging to product URL</b> - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
	
	echo "<b>Add custom Tagging to product URL</b> - possible values url_encode(TAGGING_PARAMS) default value tagging_params=utm_source=cliccaprezzi&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=utm_source=cliccaprezzi&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=from%3Dcliccaprezzi" . "\" >" . $script_basepath . "?tagging_params=from%3Dcliccaprezzi" . "</a><br /><br />";
	
	echo "<b>Display Description options</b> - possible values on, off, limited default value on<br />";
	echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br />";
	echo "<a href=\"" . $script_basepath . "?description=limited" . "\" >" . $script_basepath . "?description=limited" . "</a><br /><br />";
	
	echo "<b>Display image options</b> - possible values on, off default value on<br />";
	echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	echo "<b>Display manufacturer options</b> - possible values on, off default value on<br />";
	echo "manufacturer=on (on,off) <a href=\"" . $script_basepath . "?manufacturer=off" . "\" >" . $script_basepath . "?manufacturer=off" . "</a><br /><br />";
	
	//echo "Special price options - possible values on, off default value on<br />";
	//echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	echo "<b>Show only on stock products</b> - possible values on, off default value off<br />";
	echo "on_stock=off (on,off) <a href=\"" . $script_basepath . "?on_stock=on" . "\" >" . $script_basepath . "?on_stock=on" . "</a><br /><br />";
	
	echo "<b>Show SEO friendly url</b> - possible values on, off default value off<br />";
	echo "sef=off (on,off) <a href=\"" . $script_basepath . "?sef=on" . "\" >" . $script_basepath . "?sef=on" . "</a><br /><br />";
	
	echo "<b>Get prices in specified currency</b> - possible values USD,EUR etc. <br />";
	echo "currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?currency=EUR" . "\" >" . $script_basepath . "?currency=EUR" . "</a><br /><br />";
	
	//echo "Get texts in specified language code - possible values en,ro etc. <br />";
	//echo "language=DEFAULT_LANGUAGE_CODE <a href=\"" . $script_basepath . "?language=en" . "\" >" . $script_basepath . "?language=en" . "</a><br /><br />";
	
	//echo "Get texts in specified language id - possible values 1,2 etc. <br />";
	//echo "language_id=DEFAULT_LANGUAGE_ID <a href=\"" . $script_basepath . "?language_id=1" . "\" >" . $script_basepath . "?language_id=1" . "</a><br /><br />";
	
	echo "<b>Limit displayed products</b> - possible values integer (start,step)<br />";
	echo "limit=no_limit <a href=\"" . $script_basepath . "?limit=0,10" . "\" >" . $script_basepath . "?limit=0,10" . "</a><br /><br />";
		
	echo "<b>Add basepath to product URL</b> - possible values on, off default value off<br />";
	echo "forcepath=off (on,off) <a href=\"" . $script_basepath . "?forcepath=on" . "\" >" . $script_basepath . "?forcepath=on" . "</a><br /><br />";
	
	echo "<b>Usepath - force defined basepath to product URL</b> - possible values ex: www.site.com<br />";
	echo "usepath=BASEPATH <a href=\"" . $script_basepath . "?forcepath=on&usepath=http://www.site.com" . "\" >" . $script_basepath . "forcepath=on&usepath=http://www.site.com" . "</a><br /><br />";
		
	echo "<br />";
	
	exit;
	
}

// Force image path - change this value with the path to your files  or leave empty in order to use store settings
$use_imagepath = ""; // ex. http://www.mysite.com/images/

##### Connect to  database ################################################

// Connect to the database
$conn = @mysql_connect($mosConfig_host, $mosConfig_user, $mosConfig_password);
if (mysql_error()) {
	print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Connection error. Please check the connection settings. Bye bye...</BODY></HTML>";
	exit;
}
else {
	@mysql_select_db($mosConfig_db, $conn);
	if (mysql_error()) {
		print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Connection error. Please check the connection settings. Bye bye...</BODY></HTML>";
		exit;
	}
}

######################################################################


##### Extract options from database ################################################

// Get currencies rates values
if ($currency != "") {

	$file = "cache/daily.xml";

	$xml_parser = xml_parser_create();

	$handle = fopen($file, "r");

	$data = fread($handle, filesize($file));

	fclose($handle);

	xml_parse_into_struct($xml_parser, $data, $vals, $index);
	xml_parser_free($xml_parser);
	
	foreach ($vals as $i=>$v) {
		
		if (($v['tag'] == "RATE") && ($v['type'] == 'complete') && ($v['value'] > 0)) {
			$RATES[$v['attributes']['CURRENCY']] = $v['value'];
		}
		elseif (($v['tag'] == "CUBE") && ($v['type'] == 'complete') && ($v['attributes']['RATE'] > 0)) {
			$RATES[$v['attributes']['CURRENCY']] = $v['attributes']['RATE'];
		}
		
		if ($v['tag'] == "ORIGCURRENCY") {
			$origcurrency = $v['value'];
		}
	}
	
	$origcurrency = ($origcurrency != "") ? $origcurrency : "EUR";
	$RATES[$origcurrency] = 1;
}

// Tables variables
$prod_table = $mosConfig_dbprefix . "vm_product"; // products table
$cat_table = $mosConfig_dbprefix . "vm_category"; // categories table
$cat_xref_table = $mosConfig_dbprefix . "vm_category_xref"; // categories xref table
$manuf_table = $mosConfig_dbprefix . "vm_manufacturer"; // manufacturer table
$price_table = $mosConfig_dbprefix . "vm_product_price"; // product price table
$manuf_xref_table = $mosConfig_dbprefix . "vm_product_mf_xref"; // product manufacturer xref table
$prod_cat_xref_table = $mosConfig_dbprefix . "vm_product_category_xref"; // product category xref table
$tax_rate_table = $mosConfig_dbprefix . "vm_tax_rate"; // tax rate table
$vendor_table = $mosConfig_dbprefix . "vm_vendor"; // vendor table
$discount_table = $mosConfig_dbprefix . "vm_product_discount"; // vendor table

// Get default shopper group
$q = "SELECT * FROM " . $mosConfig_dbprefix . "vm_shopper_group WHERE " . $mosConfig_dbprefix . "vm_shopper_group.default = 1 LIMIT 1";
$r = @mysql_query($q);
if (!mysql_error()) {
	while ($field = mysql_fetch_assoc($r)) {
		$SHOPPER_GROUP = $field;
	}
	
	$shopper_group_id = (@$SHOPPER_GROUP['shopper_group_id'] > 0) ? $SHOPPER_GROUP['shopper_group_id'] : "";
	$add_shopper_group_cond = ($shopper_group_id > 0) ? " AND shopper_group_id = '" . $shopper_group_id . "'" : "";
}
else {
	$add_shopper_group_cond = "";
}

// Get the store's tax rate
$rate = 0;
$q = "SELECT tax_rate FROM $vendor_table, $tax_rate_table WHERE tax_country=vendor_country AND $vendor_table.vendor_id='1' ORDER BY tax_rate DESC LIMIT 0,1";
$r = @mysql_query($q);
if (!mysql_error()) {
	while ($field = mysql_fetch_assoc($r)) {
		$rate = $field['tax_rate'];
	}
}

// Get all categories
$res_cat = @mysql_query("SELECT $cat_table.category_id, $cat_table.category_name, $cat_xref_table.category_parent_id as parent_id, $cat_table.category_flypage
FROM $cat_table
LEFT JOIN $cat_xref_table ON ( $cat_table.category_id = $cat_xref_table.category_child_id )");
if (!mysql_error()) {
	while ($field = mysql_fetch_assoc($res_cat)) {
		$CAT_ARR[$field['category_id']] = $field;
	}
}

######################################################################


##### Extract products from database ###############################################

// Query database for extracting data. It might be needed to left join the categories table for extracting the category name
$image_field = ($show_image == "on") ? "$prod_table.product_full_image" : "''";
$manuf_field = ($show_manufacturer == "on") ? "$manuf_table.mf_name" : "''";

$manuf_left_join = ($show_manufacturer == "on") ? " LEFT JOIN $manuf_xref_table ON $prod_table.product_id = $manuf_xref_table.product_id LEFT JOIN $manuf_table ON $manuf_xref_table.manufacturer_id = $manuf_table.manufacturer_id " : "";

if ($show_description == "limited") {
	$description_field = "SUBSTRING($prod_table.product_desc, 1,400) AS product_desc";
}
elseif($show_description == "on") {
	$description_field = "$prod_table.product_desc";
}
else {
	$description_field = "''";
}

// Build on stock condition
if (CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1") {
	$on_stock_cond = "AND " . $mosConfig_dbprefix . "vm_product.product_in_stock > 0";
}
else{
	$on_stock_cond = ($on_stock_only == "on") ? "AND " . $mosConfig_dbprefix . "vm_product.product_in_stock > 0" : "";
}

// Build limit filter
if ($limit != "") {
	$limit_arr = explode(",", $limit);
	$limit_cond = ($limit_arr[0] >= 0 && @$limit_arr[1] > 0) ? " LIMIT " . $limit_arr[0] . "," . @$limit_arr[1] : (($limit_arr[0] > 0) ? " LIMIT 0," . $limit_arr[0] : "");
}
else {
	$limit_cond = "";
}

// Enable SQL_BIG_SELECTS
$res  = @mysql_query("SET SESSION SQL_BIG_SELECTS=1");

$q = "SELECT $cat_table.category_id, " . $manuf_field . ", $prod_table.product_sku, $prod_table.product_id, $prod_table.product_name, " . $description_field . ", " . $image_field . ", $price_table.product_price, IF(($price_table.product_currency = 'E'), 'EUR', $price_table.product_currency) AS product_currency, $price_table.shopper_group_id, $prod_table.product_weight, $tax_rate_table.tax_rate, $discount_table.amount, $discount_table.is_percent, $discount_table.start_date, $discount_table.end_date, $prod_table.product_url, $prod_table.product_in_stock
FROM $prod_table
LEFT JOIN $prod_cat_xref_table ON $prod_table.product_id = $prod_cat_xref_table.product_id
LEFT JOIN $cat_table ON $prod_cat_xref_table.category_id = $cat_table.category_id
" . $manuf_left_join . "
LEFT JOIN $price_table ON ($prod_table.product_id = $price_table.product_id " . $add_shopper_group_cond . " AND ($price_table.price_quantity_start <= 1 OR $price_table.price_quantity_start IS NULL))
LEFT JOIN $tax_rate_table ON $prod_table.product_tax_id = $tax_rate_table.tax_rate_id
LEFT JOIN $discount_table ON $prod_table.product_discount_id = $discount_table.discount_id
WHERE $prod_table.product_publish = 'Y' AND $prod_table.product_parent_id = 0 " . $on_stock_cond . "
ORDER BY $prod_table.product_id ASC, $cat_table.category_id DESC" . addslashes($limit_cond);

$r = @mysql_query($q);

###################################################################


##### Print product data ####################################################

// There are no errors so we can continue
if (!mysql_error()) {

	$current_id = 0;
		
	while (list($cat_id, $prod_manufacturer, $prod_model, $prod_id, $prod_name, $prod_desc, $prod_image, $prod_price, $prod_currency, $shopper_group_id, $product_weight, $tax_rate, $discount_amount, $discount_is_percent, $discount_start_date, $discount_end_date, $product_sef_url, $product_in_stock) = mysql_fetch_row($r)) {
		
		// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
		$product_id = $prod_id;
		if ($current_id == $product_id) {
			continue;
		}
		else {
			$current_id = $product_id;
		}

		// Clean description
		$prod_desc = smfeed_clean_description($prod_desc);
		
		// Get price
		if ($tax_rate != NULL) {
			if ($apply_taxes == "on") {
				$prod_price *= ($tax_rate + 1);
			}
		}
		elseif ($rate > 0) {
			// if we didn't find a product tax rate id, let's use the store's tax rate
			if ($apply_storetaxes == "on") {
				$prod_price *= ($rate + 1);
			}
		}	
		$prod_price = round( $prod_price, 2 );
		
		// Apply product discount
		$now_date_time = mktime(date("G"),date("i"),date("s"),date("n"),date("j"),date("Y"));
		if ($apply_discount == "on" && $discount_amount > 0 && (($discount_start_date < $now_date_time || $discount_start_date == 0) && ($now_date_time < $discount_end_date || $discount_end_date == 0))) {
			if ($discount_is_percent > 0) {
				$prod_price -= ($prod_price * $discount_amount) / 100;
			}
			else {
				$prod_price -= $discount_amount;
			}
		}
		$prod_price = round( $prod_price, 2 );
		
		// Clean product name (new lines)
		$prod_name = str_replace("\n", "", strip_tags($prod_name));
		$prod_name = str_replace("\r", "", strip_tags($prod_name));
		$prod_name = str_replace("\t", " ", strip_tags($prod_name));
		
		// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
		
		// Limit description size
		if ($show_description == "limited") {
			$prod_desc = smfeed_replace_not_in_tags("\n", "<BR />", $prod_desc);
			$prod_desc = str_replace("\n", " ", $prod_desc);
			$prod_desc = str_replace("\r", "", $prod_desc);
			$prod_desc = strip_tags($prod_desc);
			$prod_desc = substr(trim($prod_desc), 0, 300);
		}
		elseif ($show_description == "on") {
			$prod_desc = smfeed_replace_not_in_tags("\n", "<BR />", $prod_desc);
			$prod_desc = str_replace("\n", " ", $prod_desc);		
			$prod_desc = str_replace("\r", "", $prod_desc);
			$prod_desc = str_replace("\t", " ", $prod_desc);
		}
						
		// Get category name
		$category_name = smfeed_get_full_cat($cat_id, $CAT_ARR);		
		
		$category_flypage = ($CAT_ARR[$cat_id]['category_flypage'] != "") ? $CAT_ARR[$cat_id]['category_flypage'] : "shop.flypage";
		
		if ($sef == "on") {
			if ($product_sef_url != "") {
				$prod_url = smfeed_get_product_sef_url($product_sef_url);
			}
			else {
				$prod_url = smfeed_get_sef_url($prod_id, $prod_name, $cat_id, $CAT_ARR);
			}
		}
		else {
			$prod_url = smfeed_get_product_url($prod_id, $cat_id, $category_flypage);	
		}
		
		$prod_url = str_replace("administrator/", "", $prod_url);
		
		// Add GA Tagging parameters to url
		if ($add_tagging == "on") {
			$and_param = (preg_match("/\?/", $prod_url)) ? "&" : "?";
			$prod_url = $prod_url . $and_param . $tagging_params;
		}
		
		if ($use_imagepath != "") {
			$prod_image = ($prod_image != "") ? $use_imagepath . $prod_image : "";
		}
		else {
			$prod_image = ($prod_image != "") ? smfeed_get_product_image($prod_image) : "";
		}
		
		$prod_image = str_replace("administrator/", "", $prod_image);
						
		// Add VAT to prices
		if ($add_vat == "on") {
			$prod_price = $prod_price * $vat_value;
		}
		
		// Aplly currency exchange
		if ($currency != "") {
			
			// If both currency codes match, do nothing
			if( $prod_currency == $currency ) {		
				// Continue
			}
			else {
				$valA = $RATES[$prod_currency];
				$valB = $RATES[$currency];
				
				if ($origcurrency == $currency) {
					$prod_price = $prod_price * $valA / $valB;
				}
				else {
					$prod_price = $prod_price * $valB / $valA;
				}
				
				$prod_currency = $currency;
			}
			$prod_price = round($prod_price, 2);
		}
		
		################################################
		
		// Clean product names and descriptions (separators)
		if ($datafeed_separator == "\t") {
			$category_name = str_replace("\t", " ", $category_name);
			// Continue... tabs were already removed
		}
		elseif ($datafeed_separator == "|") {
			$prod_name = str_replace("|", " ", strip_tags($prod_name));
			$prod_desc = str_replace("|", " ", $prod_desc);
			$category_name = str_replace("|", " ", $category_name);
		}
		else {
			print "Incorrect columns separator.";
			exit;		
		}
				
		// Build stock conditions
		if (CHECK_STOCK && $add_availability == "on") {
			if ($product_in_stock > 0) {
				$availability = "In stock";
			}
			else {
				if (PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS == "1") {
						$availability = "Out of sock";
				}
				else {
					$availability = "Out of stock";
				}
			}
		}
		elseif($add_availability == "on") {
			$availability = "In stock";
		}
		else {
			$availability = "";
		}	
		
		// Add Shipping
		$shipping_value = "";
		
		// Add gtin
		$gtin = "";
		
		// Output the datafeed content
		// Category, Manufacturer, Model, ProdCode, ProdName, ProdDescription, ProdURL, ImageURL, Price, Currency, Shipping value, Availability, GTIN (UPC/EAN/ISBN) 
		print
			$category_name . $datafeed_separator .
			$prod_manufacturer . $datafeed_separator .
			$prod_model . $datafeed_separator .
			$prod_id . $datafeed_separator .
			$prod_name . $datafeed_separator .
			$prod_desc . $datafeed_separator .
			$prod_url . $datafeed_separator .
			$prod_image . $datafeed_separator .
			$prod_price . $datafeed_separator .
			$prod_currency . $datafeed_separator .
			$shipping_value . $datafeed_separator .
			$availability . $datafeed_separator . 
			$gtin . "\n";
				
	}
}
else {
	print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Query error: " . mysql_error() . "</BODY></HTML>";	
}

###################################################################


##### Functions ########################################################

// Function to return the Product URL based on your product ID
function smfeed_get_product_url($prod_id, $cat_id, $flypage){
	global $mosConfig_live_site;
	return $mosConfig_live_site . "/index.php?page=shop.product_details&flypage=" . $flypage . "&product_id=" . $prod_id . "&category_id=" . $cat_id . "&option=com_virtuemart";
}

// Function to return the SEF Product URL based on your product url
function smfeed_get_product_sef_url($product_sef_url){
	global $mosConfig_live_site;
	return $mosConfig_live_site . "/" . $product_sef_url;
}

// Function to return the Product URL based on your product ID
function smfeed_get_sef_url($prod_id, $prod_name, $cat_id, $CATEGORY_ARR){
	global $mosConfig_live_site;
	
	$cat_str_key = smfeed_build_str_key(smfeed_html_to_text($CATEGORY_ARR[$cat_id]['category_name']));
	$prod_str_key = smfeed_build_str_key($prod_name);
		
	return str_replace("administrator/", "", $mosConfig_live_site . "/" . $cat_str_key . "/" . $prod_str_key . ".html");
	
}

// Function to return the Product Image based on your product image or optionally Product ID
function smfeed_get_product_image($prod_image){
	global $mosConfig_live_site;
	
	if ($prod_image == "") {
		return false;
	}
	else {
	
		if (preg_match("/http\:\/\//", $prod_image)) {
			return str_replace("administrator/", "", $prod_image);
		}
		else {
			return str_replace("administrator/", "", $mosConfig_live_site . "/components/com_virtuemart/shop_image/product/" . $prod_image);
		}
	}
}

// Function to get category with full path
function smfeed_get_full_cat($cat_id, $CATEGORY_ARR) {

	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['category_name'];
	
	if (@$item_arr['parent_id'] > 0) {
		while (sizeof(@$CATEGORY_ARR[$item_arr['parent_id']]) > 0 && is_array(@$CATEGORY_ARR[$item_arr['parent_id']]) ) {
			
			$cat_name = $CATEGORY_ARR[$item_arr['parent_id']]['category_name'] . " > " . $cat_name;		
			$item_arr = $CATEGORY_ARR[$item_arr['parent_id']];
		}
	}
	// Strip html from category name
	$cat_name = smfeed_html_to_text($cat_name);
	
	return $cat_name;
}

function smfeed_html_to_text($string){

	$search = array (
		"'<script[^>]*?>.*?</script>'si",  // Strip out javascript
		"'<[\/\!]*?[^<>]*?>'si",  // Strip out html tags
		"'([\r\n])[\s]+'",  // Strip out white space
		"'&(quot|#34);'i",  // Replace html entities
		"'&(amp|#38);'i",
		"'&(lt|#60);'i",
		"'&(gt|#62);'i",
		"'&(nbsp|#160);'i",
		"'&(iexcl|#161);'i",
		"'&(cent|#162);'i",
		"'&(pound|#163);'i",
		"'&(copy|#169);'i",
		"'&(reg|#174);'i",
		"'&#8482;'i",
		"'&#149;'i",
		"'&#151;'i"
		);  // evaluate as php
	
	$replace = array (
		" ",
		" ",
		"\\1",
		"\"",
		"&",
		"<",
		">",
		" ",
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&copy;",
		"&reg;",
		"<sup><small>TM</small></sup>",
		"&bull;",
		"-",
		);
	
	$text = preg_replace ($search, $replace, $string);
	return $text;
	
}

function smfeed_clean_description($string){

	$search = array (
		"'<html>'i",
		"'</html>'i",
		"'<body>'i",
		"'</body>'i",
		"'<head>.*?</head>'si",
		"'<!DOCTYPE[^>]*?>'si"
		); 
		
	$replace = array (
		"",
		"",
		"",
		"",
		"",
		""
		); 
		
	$text = preg_replace ($search, $replace, $string);
	return $text;

}

function smfeed_build_str_key($text){
	
	$text = str_replace(" ", "-", trim(smfeed_string_clean_search($text)));
	$text = rawurlencode(strtolower($text));
	
	$text = strtolower(smfeed_clean_accents($text));
	
	$text = rawurldecode($text);
	
	return $text;
}

function smfeed_clean_accents($text){

	$search = array (
		
		"'%C4%99'", #e
		"'%C3%A8'", #e
		"'%C3%A9'", #e
		"'%C3%AA'", #e
		"'%C3%AB'", #e
		"'%C3%89'", #e
		"'%C3%88'", #E
		"'%C3%8A'", #E
		
		"'%C4%85'", #a
		"'%C3%A3'", #a
		"'%C3%A0'", #a
		"'%C3%A4'", #a
		"'%C3%A2'", #a	
		"'%C3%A1'", #a
		"'%C3%A5'", #a
		"'%C3%81'", #A
		"'%C3%82'", #A
		"'%C3%84'", #A
		"'%C3%85'", #A
		"'%C3%80'", #A
		
		"'%C4%87'", #c
		"'%C3%A7'", #c
		"'%C3%87'", #C
		
		"'%C5%9B'", #s
		"'%C5%A1'", #s
		"'%C5%A0'", #S
		"'%C5%9A'", #S
		
		"'%C3%B0'", #d
		"'%C3%B1'", #n
		"'%C3%BD'", #y
		"'%C4%9F'", #g
		
		"'%C4%B1'", #i
		"'%C3%AE'", #i
		"'%C3%AD'", #i
		"'%C3%AF'", #i
		"'%C3%AC'", #i
		"'%C3%8D'", #I
		"'%C3%8E'", #I
		"'%C4%B0'", #I
		
		"'%C5%82'", #l
		
		"'%C5%84'", #n
		
		"'%C3%BA'", #u
		"'%C3%BB'", #u
		"'%C3%B9'", #u
		"'%C3%BC'", #u
		"'%C5%B1'", #u
		
		"'%C3%9C'", #U
		
		"'%C3%B4'", #o
		"'%C3%B3'", #o
		"'%C3%91'", #o
		"'%C3%B6'", #o
		"'%C5%91'", #o
		"'%C3%B2'", #o
		"'%C3%B5'", #o
		"'%C3%93'", #O
		"'%C3%96'", #O
		
		"'%C3%9F'", #ss
		"'%C5%BC'", #z
		"'%C5%BA'", #z
		"'%C5%BB'", #Z
		
		"'%C3%A6'", #ae
		"'%C3%B8'", #oe
		
		"'%C2%AE'",
		"'%C2%B4'",
		"'%E2%84%A2'",
		
	);
	
	$replace = array (
		
		"e",
		"e",
		"e",
		"e",
		"e",
		"e",
		"E",
		"E",
		
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"A",
		"A",
		"A",
		"A",
		"A",
		
		"c",
		"c",
		"C",
		
		"s",
		"s",
		"S",
		"S",
		
		"d",
		"n",
		"y",
		"g",
		
		"i",
		"i",
		"i",
		"i",
		"i",
		"I",
		"I",
		"I",
		
		"l",
		
		"n",
		
		"u",
		"u",
		"u",
		"u",
		"u",
		
		"U",
		
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"O",
		"O",
		
		"ss",
		"z",
		"z",
		"Z",
		
		"ae",
		"oe",
		
		"",
		"",
		"",
		
	);
	
	$text = preg_replace($search, $replace, $text);
	
	return $text;

}

// CLEANS STRINGS
function smfeed_string_clean_search($string){
	
	$trans = get_html_translation_table(HTML_ENTITIES);
	$trans = array_flip ($trans);
	$string = strtr($string, $trans);
	
	$search = array (
		"','",
		"'&quot;'",
		"'&lt;'",
		"'&gt;'",
		"'%&pound;'",
		"'%&euro;'",
		"'-'",
		"'~'",
		"'!'",
		"'\?'",
		"'@'",
		"'#'",
		"'\\$'",
		"'%'",
		"'\^'",
		"'&'",
		"'\*'",
		"'\('",
		"'\)'",
		"'_'",
		"'='",
		"'\''",
		"'\['",
		"'\]'",
		"'{'",
		"'}'",
		"'\|'",
		"'\"'",
		"':'",
		"';'",
		"'\\\'",
		"'>'",
		"'<'",		
		"'[\r]+'",
		"'[\n]+'",
		"'[\t]+'",
		"'[\s]+'",
		//"'\.'",
		//"'\+'",
		//"'/'",
	);
	
	$replace = array (
		"",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		//" ",
		//" ",
		//" ",
	);
	
	$string = preg_replace($search, $replace, $string);
	
	return $string;
	
}

function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

###################################################################

exit;

?>